#!/usr/bin/env node
var stringSimilarity = require('string-similarity');
var fs = require("fs");
var userArgs = process.argv.slice(2);

var possible_args = [
    {name: 'create-gulp', call: createGulp},
    {name: 'init-project', call: init},
    {name: '--help', call: help}
];

var match;
for(var arg = 0; arg < possible_args.length; arg++){
    if(possible_args[arg].name == userArgs[0]){
        match = possible_args[arg];
    }
}

if(!match){
    var simpoints = {points: 0, match: ""};
    for(var arg = 0; arg < possible_args.length; arg++){
        var similarity = stringSimilarity.compareTwoStrings(possible_args[arg].name, userArgs[0]);
        if(similarity > simpoints.points){
            simpoints.points = similarity;
            simpoints.match = possible_args[arg].name;
        }
    }
    console.log("Comando não encontrado, você quis dizer " + simpoints.match + "?");
    console.log("Para consultar os comandos disponíveis utilize --help.")
    process.exit(-1);
}

else{
    match.call();
}

function help(){
    console.log("Possíveis comandos: \n");
    for(var arg = 0; arg < possible_args.length; arg++){
        console.log(possible_args[arg].name);
    }
}

function createGulp(){
    var filename = __dirname + "/assets/default_gulp.txt";
    fs.readFile(filename, 'utf8', function(err, data) {
        if (!err){
            const readline = require('readline');

            const rl = readline.createInterface({
                input: process.stdin,
                output: process.stdout
            });

            rl.question('Url da página? ', (answer) => {
                data = data.replaceAll('{{proxy.url}}', answer);
                fs.writeFile('gulpfile.js', data, function(err) {
                    if(!err){
                        console.log("Gulpfile criado com sucesso.");
                    }
                });
                rl.close();
            });
        }
    });
}

function init(){

}

String.prototype.replaceAll = function(search, replacement) {
    var target = this;
    return target.split(search).join(replacement);
};
